xref: /illumos-gate/usr/src/test/util-tests/tests/date/date_test.ksh (revision d17be682a2c70b4505d43c830bbd2603da11918d)
1#!/bin/ksh
2#
3# This file and its contents are supplied under the terms of the
4# Common Development and Distribution License ("CDDL"), version 1.0.
5# You may only use this file in accordance with the terms of version
6# 1.0 of the CDDL.
7#
8# A full copy of the text of the CDDL should have accompanied this
9# source.  A copy of the CDDL is also available via the Internet at
10# http://www.illumos.org/license/CDDL.
11#
12
13#
14# Copyright 2019 Joyent, Inc.
15#
16
17#
18# Basic tests of date -r.
19#
20
21export LC_ALL=C
22
23date_arg0="$(basename $0)"
24date_prog=/usr/bin/date
25date_curcmd=
26
27fatal()
28{
29	typeset msg="$*"
30	[[ -z "$msg" ]] && msg="failed"
31	echo "TEST FAILED: $date_arg0: $msg" >&2
32	exit 1
33}
34
35compare()
36{
37	typeset time=$1
38	typeset exp=$2
39	typeset tz=$3
40	typeset val ret
41
42	date_curcmd="TZ=$3 $date_prog -r $1"
43	val=$(TZ=$3 $date_prog -r $1)
44	ret=$?
45	if [[ $ret -ne 0 ]]; then
46		fatal "date not exit zero, exited $ret; command: $date_curcmd"
47	fi
48	if [[ -z "$val" ]]; then
49		fatal "date returned no output; command: $date_curcmd"
50	fi
51
52	if [[ "$val" != "$exp" ]]; then
53		fatal "date output mismatch; command: $date_curcmd; expected: " \
54		    "$exp; found: $val"
55	fi
56}
57
58if [[ -n $DATE ]]; then
59	date_prog=$DATE
60fi
61
62#
63# date -r supports base 10, hex, and octal
64#
65compare 0 "Thu Jan  1 00:00:00 UTC 1970" UTC
66compare 0 "Wed Dec 31 16:00:00 PST 1969" US/Pacific
67compare 0 "Thu Jan  1 09:00:00 JST 1970" Japan
68compare 1234567890 "Fri Feb 13 23:31:30 UTC 2009" UTC
69compare -1234567890 "Tue Nov 18 00:28:30 UTC 1930" UTC
70compare 2147483647 "Tue Jan 19 03:14:07 UTC 2038" UTC
71compare -2147483647 "Fri Dec 13 20:45:53 UTC 1901" UTC
72compare 558028800 "Mon Sep  7 16:00:00 UTC 1987" UTC
73compare 0x2142d800 "Mon Sep  7 16:00:00 UTC 1987" UTC
74compare 04120554000 "Mon Sep  7 16:00:00 UTC 1987" UTC
75
76#
77# Test the file related logic
78#
79env TZ=UTC touch -t 201712042323.23 $TMPDIR/test.$$
80compare "$TMPDIR/test.$$" "Mon Dec  4 23:23:23 UTC 2017" UTC
81rm -f $TMPDIR/test.$$
82
83#
84# date -r should not work with -a
85#
86if $date_prog -r 0 -a 10 2>/dev/null; then
87	fatal "date -r 0 -a 10 exited zero when it should have failed"
88fi
89
90#
91# date -r and -R or -u should work together
92#
93compare "0 -R" "Thu, 01 Jan 1970 02:00:00 +0200" Africa/Cairo
94compare "0 -u" "Thu Jan  1 00:00:00 GMT 1970" Europe/Rome
95
96echo "TEST PASSED: $date_arg0"
97